#! /usr/bin/perl -w
# use XML::Writer;
use XML::Simple;
use Finance::Quote;
use DBD::mysql;
# use Data::Dumper;

# FetchStocks
sub fetch_stocks {

	# objects
	my $q = (Finance::Quote)->new;
	my $xs = new XML::Simple;

	# static variables
	my %stock_info;
	my %stock_hash;

	# open stock list xml
	my $stock_list_ref_hash_ref = $xs->XMLin('./xml/stock_list.xml');
	my %stock_list_ref_hash = %$stock_list_ref_hash_ref;
	my $stock_list_ref = $stock_list_ref_hash{'stocksymbol'};
	my @stock_list = @$stock_list_ref;

	# open stock attributes xml
	my $stock_attributes_ref_hash_ref = $xs->XMLin('./xml/stock_attributes.xml');
	my %stock_attributes_ref_hash = %$stock_attributes_ref_hash_ref;
	my $stock_attributes_ref = $stock_attributes_ref_hash{'attribute'};
	my @stock_attributes = @$stock_attributes_ref;

	# io
	my $fh;
	my $stock_hash_ref;
	# print "Fetching stocks...\n";
	%stock_info = $q->fetch('usa', @stock_list);

	# create single dimensional hash and store it
	foreach $stock (@stock_list) {
		my %temp_hash;
		foreach $attr (@stock_attributes) {
			my @maybe;
			$maybe[0] = $stock_info{$stock, $attr};
			if ((defined($maybe[0]))) {
				$temp_hash{$attr} = \@maybe;
			}
		}
		$stock_hash{$stock} = \%temp_hash;
	}

	$stock_hash_ref = \%stock_hash;
	# i/o
	open($fh, '>>./xml/stock_history_file.xml');
	print $fh "<!--";

	($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time);
	printf $fh "%4d-%02d-%02d %02d:%02d:%02d", $year + 1900, $mon + 1, $mday, $hour, $min, $sec;

	print $fh "($wday, $yday, $isdst) -->\n";

	print $xs->XMLout($stock_hash_ref);
	#print $fh "\n";
	#return "true";
}

fetch_stocks();
sleep(30);